package lesenallermailheader;

/**
 * Title:        Lesen aller Header
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */
import javax.mail.*;
import javax.mail.internet.*;
import java.util.*;


public class AllHeaderClient {

  public static void main(String[] args) {

    if (args.length == 0) {
      System.err.println(
       "Usage: java AllHeaderClient protocol://username@host:port/foldername");
      return;
    }

    URLName server = new URLName(args[0]);

    try {

      Session session = Session.getDefaultInstance(new Properties(),
       new MailAuthenticator(server.getUsername()));

      // Verbindungsaufbau
      Folder folder = session.getFolder(server);
      if (folder == null) {
        System.out.println("Folder " + server.getFile() + " nicht gefunden.");
        System.exit(1);
      }
      folder.open(Folder.READ_ONLY);

      // Lesen der Nachrichten
      Message[] messages = folder.getMessages();
      for (int i = 0; i < messages.length; i++) {
        System.out.println("------------ Message " + (i+1)
         + " ------------");
        // Unterschied
        Enumeration headers = messages[i].getAllHeaders();
        while (headers.hasMoreElements()) {
          Header h = (Header) headers.nextElement();
          System.out.println(h.getName() + ": " + h.getValue());
        }
        System.out.println();
      }

      // Verbindungsabbau
      // Nachrichten bleiben auf dem Server
      folder.close(false);

    }
    catch (Exception e) {
      e.printStackTrace();
    }

    // GUI herunterfahren
    // exit
    System.exit(0);

  }

}