package readmailheader;

/**
 * Title:        Lesen von Mail Header Informationen
 * Description:  Einfacher Mail  Client, der die Header Informatione liest. Diese werden angezeigt. Das Programm unterscheidet sich kaum von den bisherigen, bis auf die Einschrnkung auf die Headerinfo.
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */
import javax.mail.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


public class MailAuthenticator extends Authenticator {

  private JDialog passwordDialog = new JDialog(new JFrame(), true);
  private JLabel mainLabel = new JLabel(
   "Bitte Benutzernamen und Passwort eingeben: ");
  private JLabel userLabel = new JLabel("Benutzername: ");
  private JLabel passwordLabel = new JLabel("Passwort: ");
  private JTextField usernameField = new JTextField(20);
  private JPasswordField passwordField = new JPasswordField(20);
  private JButton okButton = new JButton("OK");

  public MailAuthenticator() {
    this("");
  }

  public MailAuthenticator(String username) {

    Container pane = passwordDialog.getContentPane();
    pane.setLayout(new GridLayout(4, 1));
    pane.add(mainLabel);
    JPanel p2 = new JPanel();
    p2.add(userLabel);
    p2.add(usernameField);
    usernameField.setText(username);
    pane.add(p2);
    JPanel p3 = new JPanel();
    p3.add(passwordLabel);
    p3.add(passwordField);
    pane.add(p3);
    JPanel p4 = new JPanel();
    p4.add(okButton);
    pane.add(p4);
    passwordDialog.pack();

    ActionListener al = new HideDialog();
    okButton.addActionListener(al);
    usernameField.addActionListener(al);
    passwordField.addActionListener(al);

  }

  class HideDialog implements ActionListener {

    public void actionPerformed(ActionEvent e) {
      passwordDialog.hide();
    }

  }

  public PasswordAuthentication getPasswordAuthentication() {

    passwordDialog.show();

    // getPassword() liefert aus Sicherheitsgrnden ein Array
    // Dieses mssen wir in eine Zeichenkette umwandeln fr den
    // PasswordAuthentication()Konstruktor
    String password = new String(passwordField.getPassword());
    String username = usernameField.getText();
    // Lschen des Passwortes
    // fr alle Flle
    passwordField.setText("");
    return new PasswordAuthentication(username, password);

  }

}