package sichererpop3client;

/**
 * Title:        Sicherer POP3 Client
 * Description:  Ergnzung zum POP3 Client:
 * das Passwort und der Benutzer knnen zur Laufzeit eingegeben werden.
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

import javax.mail.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


public class MailAuthenticator extends Authenticator {

  private JDialog passwordDialog = new JDialog(new JFrame(), true);
  private JLabel mainLabel = new JLabel(
   "Bitte Benutzernamen und Passwort eingeben: ");
  private JLabel userLabel = new JLabel("Benutzernamen: ");
  private JLabel passwordLabel = new JLabel("Passwort: ");
  private JTextField usernameField = new JTextField(20);
  private JPasswordField passwordField = new JPasswordField(20);
  private JButton okButton = new JButton("OK");

  public MailAuthenticator() {
    this("");
  }

  public MailAuthenticator(String username) {

    Container pane = passwordDialog.getContentPane();
    pane.setLayout(new GridLayout(4, 1));
    pane.add(mainLabel);
    JPanel p2 = new JPanel();
    p2.add(userLabel);
    p2.add(usernameField);
    usernameField.setText(username);
    pane.add(p2);
    JPanel p3 = new JPanel();
    p3.add(passwordLabel);
    p3.add(passwordField);
    pane.add(p3);
    JPanel p4 = new JPanel();
    p4.add(okButton);
    pane.add(p4);
    passwordDialog.pack();

    ActionListener al = new HideDialog();
    okButton.addActionListener(al);
    usernameField.addActionListener(al);
    passwordField.addActionListener(al);

  }

  class HideDialog implements ActionListener {

    public void actionPerformed(ActionEvent e) {
      passwordDialog.hide();
    }

  }

  public PasswordAuthentication getPasswordAuthentication() {

    passwordDialog.show();

    // getPassword() liefert ein Array, aus Sicherheitsgrnden
    // Dieses muss in eine Zeichenkette umgewandelt werden.
    // PasswordAuthentication() constructor.
    String password = new String(passwordField.getPassword());
    String username = usernameField.getText();
    // Lschen des PWD
    // Der Provider kennt das PWD noch
    passwordField.setText("");
    return new PasswordAuthentication(username, password);

  }

}